[USACO09DEC]牛收费路径Cow Toll Paths(floyd、加路径上最大点权值的最短路径)

时间:2023-03-09 01:56:40
[USACO09DEC]牛收费路径Cow Toll Paths(floyd、加路径上最大点权值的最短路径)

https://www.luogu.org/problem/P2966

题目描述

Like everyone else, FJ is always thinking up ways to increase his revenue. To this end, he has set up a series of tolls that the cows will pay when they traverse the cowpaths throughout the farm.

The cows move from any of the N (1 <= N <= 250) pastures conveniently numbered 1..N to any other pasture over a set of M (1 <= M <= 10,000) bidirectional cowpaths that connect pairs of different pastures A_j and B_j (1 <= A_j <= N; 1 <= B_j <= N). FJ has assigned a toll L_j (1 <= L_j <= 100,000) to the path connecting pastures A_j and B_j.

While there may be multiple cowpaths connecting the same pair of pastures, a cowpath will never connect a pasture to itself. Best of all, a cow can always move from any one pasture to any other pasture by following some sequence of cowpaths.

In an act that can only be described as greedy, FJ has also assigned a toll C_i (1 <= C_i <= 100,000) to every pasture. The cost of moving from one pasture to some different pasture is the sum of the tolls for each of the cowpaths that were traversed plus a *single additional toll* that is the maximum of all the pasture tolls encountered along the way, including the initial and destination pastures.

The patient cows wish to investigate their options. They want you to write a program that accepts K (1 <= K <= 10,000) queries and outputs the minimum cost of trip specified by each query. Query i is a pair of numbers s_i and t_i (1 <= s_i <= N; 1 <= t_i <= N; s_i != t_i) specifying a starting and ending pasture.

跟所有人一样,农夫约翰以着宁教我负天下牛,休叫天下牛负我的伟大精神,日日夜夜苦思生财之道。为了发财,他设置了一系列的规章制度,使得任何一只奶牛在农场中的道路行走,都要向农夫约翰上交过路费。 农场中由N(1 <= N <= 250)片草地(标号为1到N),并且有M(1 <= M <= 10000)条双向道路连接草地A_j和B_j(1 <= A_j <= N; 1 <= B_j <= N)。

奶牛们从任意一片草地出发可以抵达任意一片的草地。FJ已经在连接A_j和B_j的双向道路上设置一个过路费L_j (1 <= L_j <= 100,000)。 可能有多条道路连接相同的两片草地,但是不存在一条道路连接一片草地和这片草地本身。最值得庆幸的是,奶牛从任意一篇草地出发,经过一系列的路径,总是可以抵达其它的任意一片草地。 除了贪得无厌,叫兽都不知道该说什么好。

FJ竟然在每片草地上面也设置了一个过路费C_i (1 <= C_i <= 100000)。从一片草地到另外一片草地的费用,是经过的所有道路的过路费之和,加上经过的所有的草地(包括起点和终点)的过路费的最大值。 任劳任怨的牛们希望去调查一下她们应该选择那一条路径。

她们要你写一个程序,接受K(1 <= K <= 10,000)个问题并且输出每个询问对应的最小花费。第i个问题包含两个数字s_i 和t_i(1 <= s_i <= N; 1 <= t_i <= N; s_i != t_i),表示起点和终点的草地。

Consider this example diagram with five pastures:

The 'edge toll' for the path from pasture 1 to pasture 2 is 3. Pasture 2's 'node toll' is 5.

To travel from pasture 1 to pasture 4, traverse pastures 1 to 3 to 5 to 4. This incurs an edge toll of 2+1+1=4 and a node toll of 4 (since pasture 5's toll is greatest), for a total cost of 4+4=8.

The best way to travel from pasture 2 to pasture 3 is to traverse pastures 2 to 5 to 3. This incurs an edge toll of 3+1=4 and a node toll of 5, for a total cost of 4+5=9.

输入格式

* Line 1: Three space separated integers: N, M, and K

* Lines 2..N+1: Line i+1 contains a single integer: C_i

* Lines N+2..N+M+1: Line j+N+1 contains three space separated

integers: A_j, B_j, and L_j

* Lines N+M+2..N+M+K+1: Line i+N+M+1 specifies query i using two space-separated integers: s_i and t_i

输出格式

* Lines 1..K: Line i contains a single integer which is the lowest cost of any route from s_i to t_i

输入输出样例

输入 #1


输出 #1

 

题目大意:

给定 N 个节点,M 条边的无向图,边有边权,点有点权,现给出 Q 个询问,每个询问查询两个节点之间的最短路径,

这里最短路径的定义是两个节点之间的最短路径与这条路径中经过的节点点权的最大值之和。

题解:

多源最短路问题,数据范围这么小,很显然就应该用 floyd 算法来处理,

由于最短路径涉及到路径中最大的点权,因此如何在决策阶段快速进行状态转移,得出路径中最大的点权是这道题考虑的核心。若每次进行枚举点权,复杂度显然爆炸。

我们重新回想一遍floyd算法的原理:

i到j有两种可能:直接到和借助中间接口k,所以取一个min就行了

我们再往下细细的想一下,k代表的是中间的接口,而且k的枚举顺序是任意的?

显然是任意的!突破口就在这:我们可以肆意的修改k的枚举顺序!,所以,这道题就解决了。

我们对点按权值从小到大重新编号,这是的中转点k代表的就是重新编号的点,k越大,点权越大

我们只需要从小到大枚举中转点k,由于k是从小到大枚举的

我们在找i,j之间的最短路的时候,我们的中转点如果只是枚举到了k,这说明了我们当前的i,j之间的最短路中并没有点权超过k点点权大的点,最后的k即作为i->j的路径上除i,j外点权的最大值,

然后就可以去跑flyod,该路径上点权的最大值即为 i,j,k 三个点中点权的最大值!

因此在开始时对点权进行排序,这样对于带点权的最短路径,时间复杂度为 O(n3)。

另:单纯计算多源最短路时,各个节点之间的顺序对答案无影响。(显然如此,故可以对点重新编号)

代码如下:

 #include <stdio.h>
#include <string.h>
#include <iostream>
#include <string>
#include <math.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <math.h>
const int INF=0x3f3f3f3f;
typedef long long LL;
const int mod=1e9+;
const double PI=acos(-);
const int maxn=;
using namespace std;
//ios::sync_with_stdio(false);
// cin.tie(NULL); int n,m,K;
struct node
{
int id;//最初编号
int cost;//点权
}point[];//存点的信息
int dis[][];//新编号的最短路径
int ans[][];//带点权的最短路径(新编号),即答案
int rank[];//存放新编号,由原始编号查找新编号 bool cmp(node a,node b)
{
return a.cost<b.cost;
} int main()
{
//freopen("sample.txt","r",stdin);
scanf("%d %d %d",&n,&m,&K);
for(int i=;i<=n;i++)
{
scanf("%d",&point[i].cost);
point[i].id=i;
}
sort(point+,point++n,cmp);//按点权从小到大排序
for(int i=;i<=n;i++)
{
rank[point[i].id]=i;//因为询问是用原始编号,这里存一下新编号
}
memset(dis,INF,sizeof(dis));
for(int i=;i<=n;i++)
{
dis[i][i]=;
}
for(int i=;i<m;i++)
{
int u,v,w;
scanf("%d %d %d",&u,&v,&w);
dis[rank[u]][rank[v]]=dis[rank[v]][rank[u]]=min(dis[rank[u]][rank[v]],w);
}
memset(ans,INF,sizeof(ans));
for(int k=;k<=n;k++)
{
for(int i=;i<=n;i++)
{
for(int j=;j<=n;j++)
{
if(i==j)
continue;
dis[i][j]=min(dis[i][j],dis[i][k]+dis[k][j]);
if(dis[i][j]==dis[i][k]+dis[k][j])//可去掉,但去掉运行时间会增加很多
ans[i][j]=min(ans[i][j],dis[i][j]+max(point[i].cost,max(point[j].cost,point[k].cost)));
}
}
}
for(int i=;i<K;i++)
{
int u,v;
scanf("%d %d",&u,&v);
printf("%d\n",ans[rank[u]][rank[v]]);
}
return ;
}